import*as Host from"../../../core/host/host.js";import*as i18n from"../../../core/i18n/i18n.js";import*as Platform from"../../../core/platform/platform.js";import*as SDK from"../../../core/sdk/sdk.js";import*as CodeMirror from"../../../third_party/codemirror.next/codemirror.next.js";import*as Buttons from"../../../ui/components/buttons/buttons.js";import*as CodeHighlighter from"../../../ui/components/code_highlighter/code_highlighter.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as IconButton from"../../../ui/components/icon_button/icon_button.js";import*as Input from"../../../ui/components/input/input.js";import*as TextEditor from"../../../ui/components/text_editor/text_editor.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import*as Dialogs from"../../../ui/components/dialogs/dialogs.js";import*as Menus from"../../../ui/components/menus/menus.js";import*as Models from"../models/models.js";import recordingViewStyles from"./recordingView.css.js";import{StepView}from"./StepView.js";import{ReplayButton}from"./ReplayButton.js";import*as SplitView from"../../../ui/components/split_view/split_view.js";import{ExtensionView}from"./ExtensionView.js";const UIStrings={mobile:"Mobile",desktop:"Desktop",latency:"Latency: {value} ms",upload:"Upload: {value}",download:"Download: {value}",editReplaySettings:"Edit replay settings",replaySettings:"Replay settings",default:"Default",environment:"Environment",screenshotForSection:"Screenshot for this section",editTitle:"Edit title",requiredTitleError:"Title is required",recording:"Recording…",endRecording:"End recording",recordingIsBeingStopped:"Stopping recording…",timeout:"Timeout: {value} ms",network:"Network",timeoutLabel:"Timeout",timeoutExplanation:"The timeout setting (in milliseconds) applies to every action when replaying the recording. For example, if a DOM element identified by a CSS selector does not appear on the page within the specified timeout, the replay fails with an error.",cancelReplay:"Cancel replay",showCode:"Show code",hideCode:"Hide code",addAssertion:"Add assertion",performancePanel:"Performance panel"},str_=i18n.i18n.registerUIStrings("panels/recorder/components/RecordingView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class RecordingFinishedEvent extends Event{static eventName="recordingfinished";constructor(){super(RecordingFinishedEvent.eventName)}}export class PlayRecordingEvent extends Event{static eventName="playrecording";data;constructor(t={targetPanel:"chrome_recorder",speed:"normal"}){super(PlayRecordingEvent.eventName),this.data=t}}export class AbortReplayEvent extends Event{static eventName="abortreplay";constructor(){super(AbortReplayEvent.eventName)}}export class RecordingChangedEvent extends Event{static eventName="recordingchanged";data;constructor(t,e){super(RecordingChangedEvent.eventName),this.data={currentStep:t,newStep:e}}}export class AddAssertionEvent extends Event{static eventName="addassertion";constructor(){super(AddAssertionEvent.eventName)}}export class RecordingTitleChangedEvent extends Event{static eventName="recordingtitlechanged";title;constructor(t){super(RecordingTitleChangedEvent.eventName,{}),this.title=t}}export class NetworkConditionsChanged extends Event{static eventName="networkconditionschanged";data;constructor(t){super(NetworkConditionsChanged.eventName,{composed:!0,bubbles:!0}),this.data=t}}export class TimeoutChanged extends Event{static eventName="timeoutchanged";data;constructor(t){super(TimeoutChanged.eventName,{composed:!0,bubbles:!0}),this.data=t}}const networkConditionPresets=[SDK.NetworkManager.NoThrottlingConditions,SDK.NetworkManager.OfflineConditions,SDK.NetworkManager.Slow3GConditions,SDK.NetworkManager.Fast3GConditions];function converterIdToFlowMetric(t){switch(t){case"puppeteer":return Host.UserMetrics.RecordingCopiedToClipboard.CopiedRecordingWithPuppeteer;case"json":return Host.UserMetrics.RecordingCopiedToClipboard.CopiedRecordingWithJSON;case"@puppeteer/replay":return Host.UserMetrics.RecordingCopiedToClipboard.CopiedRecordingWithReplay;default:return Host.UserMetrics.RecordingCopiedToClipboard.CopiedRecordingWithExtension}}function converterIdToStepMetric(t){switch(t){case"puppeteer":return Host.UserMetrics.RecordingCopiedToClipboard.CopiedStepWithPuppeteer;case"json":return Host.UserMetrics.RecordingCopiedToClipboard.CopiedStepWithJSON;case"@puppeteer/replay":return Host.UserMetrics.RecordingCopiedToClipboard.CopiedStepWithReplay;default:return Host.UserMetrics.RecordingCopiedToClipboard.CopiedStepWithExtension}}export class RecordingView extends HTMLElement{static litTagName=LitHtml.literal`devtools-recording-view`;#t=this.attachShadow({mode:"open"});#e={isPlaying:!1,isPausedOnBreakpoint:!1};#i=null;#n=!1;#s=!1;#o=!1;#r;#a=[];#l;#d=[];#c;#p;#h;#g=new Set;#u;#m=!1;#v=!0;#S=[];#w=[];#C;#y=!1;#$="";#T="";#f;#b;#I;#E=this.#x.bind(this);set data(t){this.#n=t.isRecording,this.#e=t.replayState,this.#s=t.recordingTogglingInProgress,this.#r=t.currentStep,this.#i=t.recording,this.#a=this.#i.steps,this.#d=t.sections,this.#c=t.settings,this.#p=t.recorderSettings,this.#l=t.currentError,this.#h=t.lastReplayResult,this.#v=t.replayAllowed,this.#o=!1,this.#g=t.breakpointIndexes,this.#S=t.builtInConverters,this.#w=t.extensionConverters,this.#C=t.replayExtensions,this.#I=t.extensionDescriptor,this.#T=this.#p?.preferredCopyFormat??t.builtInConverters[0]?.getId(),this.#N(),this.#M()}connectedCallback(){this.#t.adoptedStyleSheets=[recordingViewStyles,Input.textInputStyles],document.addEventListener("copy",this.#E),this.#M()}disconnectedCallback(){document.removeEventListener("copy",this.#E)}scrollToBottom(){const t=this.shadowRoot?.querySelector(".sections");t&&(t.scrollTop=t.scrollHeight)}#R(){this.dispatchEvent(new AddAssertionEvent)}#H(){this.dispatchEvent(new RecordingFinishedEvent)}#k(){this.dispatchEvent(new AbortReplayEvent)}#B(t){this.dispatchEvent(new PlayRecordingEvent({targetPanel:"chrome_recorder",speed:t.speed,extension:t.extension}))}#L(t){if(!this.#r)return"default";if(t===this.#r)return this.#l?"error":this.#e.isPlaying?this.#e.isPausedOnBreakpoint?"stopped":"current":"success";const e=this.#a.indexOf(this.#r);if(-1===e)return"default";return this.#a.indexOf(t)<e?"success":"outstanding"}#P(t){const e=this.#r;if(!e)return"default";const i=this.#d.find((t=>t.steps.includes(e)));if(!i&&this.#l)return"error";if(t===i)return"success";return this.#d.indexOf(i)>=this.#d.indexOf(t)?"success":"outstanding"}#F(t,e,i){const n=this.#a.indexOf(e);return LitHtml.html`
      <${StepView.litTagName}
      @click=${this.#U}
      @mouseover=${this.#V}
      @copystep=${this.#A}
      .data=${{step:e,state:this.#L(e),error:this.#r===e?this.#l:void 0,isFirstSection:!1,isLastSection:i&&this.#a[this.#a.length-1]===e,isStartOfGroup:!1,isEndOfGroup:t.steps[t.steps.length-1]===e,stepIndex:n,hasBreakpoint:this.#g.has(n),sectionIndex:-1,isRecording:this.#n,isPlaying:this.#e.isPlaying,removable:this.#a.length>1,builtInConverters:this.#S,extensionConverters:this.#w,isSelected:this.#u===e,recorderSettings:this.#p}}
      ></${StepView.litTagName}>
    `}#V=t=>{const e=t.target,i=e.step||e.section?.causingStep;i&&!this.#u&&this.#D(i)};#U(t){t.stopPropagation();const e=t.target,i=e.step||e.section?.causingStep||null;this.#u!==i&&(this.#u=i,this.#M(),i&&this.#D(i,!0))}#j(){void 0!==this.#u&&(this.#u=void 0,this.#M())}#K(t){"Enter"===t.key&&(t.preventDefault(),this.#O(t))}#O(t){t.stopPropagation(),this.#m=!this.#m,this.#M()}#_(t){const e=networkConditionPresets.find((e=>e.i18nTitleKey===t.itemValue));this.dispatchEvent(new NetworkConditionsChanged(e?.i18nTitleKey===SDK.NetworkManager.NoThrottlingConditions.i18nTitleKey?void 0:e))}#W(t){const e=t.target;e.checkValidity()?this.dispatchEvent(new TimeoutChanged(Number(e.value))):e.reportValidity()}#q=t=>{const e=t.target.innerText.trim();if(!e)return this.#o=!0,void this.#M();this.dispatchEvent(new RecordingTitleChangedEvent(e))};#G=t=>{switch(t.code){case"Escape":case"Enter":t.target.blur(),t.stopPropagation()}};#z=()=>{const t=this.#t.getElementById("title-input");t.focus();const e=document.createRange();e.selectNodeContents(t),e.collapse(!1);const i=window.getSelection();i?.removeAllRanges(),i?.addRange(e)};#J=t=>{const e=t.target;e.matches(".wrapping-label")&&e.querySelector("devtools-select-menu")?.click()};async#Q(t){let e=[...this.#S,...this.#w].find((t=>t.getId()===this.#p?.preferredCopyFormat));if(e||(e=this.#S[0]),!e)throw new Error("No default converter found");let i="";t?i=await e.stringifyStep(t):this.#i&&([i]=await e.stringify(this.#i)),Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(i);const n=t?converterIdToStepMetric(e.getId()):converterIdToFlowMetric(e.getId());Host.userMetrics.recordingCopiedToClipboard(n)}#A(t){t.stopPropagation(),this.#Q(t.step)}async#x(t){t.target===document.body&&(t.preventDefault(),await this.#Q(this.#u),Host.userMetrics.keyboardShortcutFired("chrome_recorder.copy-recording-or-step"))}#X(){if(!this.#c)return LitHtml.html``;const t=[];this.#c.viewportSettings&&(t.push(LitHtml.html`<div>${this.#c.viewportSettings.isMobile?i18nString(UIStrings.mobile):i18nString(UIStrings.desktop)}</div>`),t.push(LitHtml.html`<div class="separator"></div>`),t.push(LitHtml.html`<div>${this.#c.viewportSettings.width}×${this.#c.viewportSettings.height} px</div>`));const e=[];if(this.#m){const t=this.#c.networkConditionsSettings?.i18nTitleKey||SDK.NetworkManager.NoThrottlingConditions.i18nTitleKey,i=networkConditionPresets.find((e=>e.i18nTitleKey===t));let n="";i&&(n=i.title instanceof Function?i.title():i.title),e.push(LitHtml.html`<div class="editable-setting">
        <label class="wrapping-label" @click=${this.#J}>
          ${i18nString(UIStrings.network)}
          <${Menus.SelectMenu.SelectMenu.litTagName}
            @selectmenuselected=${this.#_}
            .disabled=${!this.#a.find((t=>"navigate"===t.type))}
            .showDivider=${!0}
            .showArrow=${!0}
            .sideButton=${!1}
            .showSelectedItem=${!0}
            .showConnector=${!1}
            .position=${"bottom"}
            .buttonTitle=${n}
          >
            ${networkConditionPresets.map((e=>LitHtml.html`<${Menus.Menu.MenuItem.litTagName}
                .value=${e.i18nTitleKey}
                .selected=${t===e.i18nTitleKey}
              >
                ${e.title instanceof Function?e.title():e.title}
              </${Menus.Menu.MenuItem.litTagName}>`))}
          </${Menus.SelectMenu.SelectMenu.litTagName}>
        </label>
      </div>`),e.push(LitHtml.html`<div class="editable-setting">
        <label class="wrapping-label" title=${i18nString(UIStrings.timeoutExplanation)}>
          ${i18nString(UIStrings.timeoutLabel)}
          <input
            @input=${this.#W}
            required
            min=${Models.SchemaUtils.minTimeout}
            max=${Models.SchemaUtils.maxTimeout}
            value=${this.#c.timeout||Models.RecordingPlayer.defaultTimeout}
            class="devtools-text-input"
            type="number">
        </label>
      </div>`)}else this.#c.networkConditionsSettings?this.#c.networkConditionsSettings.title?e.push(LitHtml.html`<div>${this.#c.networkConditionsSettings.title}</div>`):e.push(LitHtml.html`<div>
            ${i18nString(UIStrings.download,{value:Platform.NumberUtilities.bytesToString(this.#c.networkConditionsSettings.download)})},
            ${i18nString(UIStrings.upload,{value:Platform.NumberUtilities.bytesToString(this.#c.networkConditionsSettings.upload)})},
            ${i18nString(UIStrings.latency,{value:this.#c.networkConditionsSettings.latency})}
          </div>`):e.push(LitHtml.html`<div>${SDK.NetworkManager.NoThrottlingConditions.title instanceof Function?SDK.NetworkManager.NoThrottlingConditions.title():SDK.NetworkManager.NoThrottlingConditions.title}</div>`),e.push(LitHtml.html`<div class="separator"></div>`),e.push(LitHtml.html`<div>${i18nString(UIStrings.timeout,{value:this.#c.timeout||Models.RecordingPlayer.defaultTimeout})}</div>`);const i=!this.#n&&!this.#e.isPlaying,n={"settings-title":!0,expanded:this.#m},s={expanded:this.#m,settings:!0};return LitHtml.html`
      <div class="settings-row">
        <div class="settings-container">
          <div
            class=${LitHtml.Directives.classMap(n)}
            @keydown=${i&&this.#K}
            @click=${i&&this.#O}
            tabindex="0"
            role="button"
            aria-label=${i18nString(UIStrings.editReplaySettings)}>
            <span>${i18nString(UIStrings.replaySettings)}</span>
            ${i?LitHtml.html`<${IconButton.Icon.Icon.litTagName}
                    class="chevron"
                    .data=${{iconName:"triangle-down",color:"var(--sys-color-on-surface)"}}>
                  </${IconButton.Icon.Icon.litTagName}>`:""}
          </div>
          <div class=${LitHtml.Directives.classMap(s)}>
            ${e.length?e:LitHtml.html`<div>${i18nString(UIStrings.default)}</div>`}
          </div>
        </div>
        <div class="settings-container">
          <div class="settings-title">${i18nString(UIStrings.environment)}</div>
          <div class="settings">
            ${t.length?t:LitHtml.html`<div>${i18nString(UIStrings.default)}</div>`}
          </div>
        </div>
      </div>
    `}#Y(){const t=[...this.#S||[],...this.#w||[]].find((t=>t.getId()===this.#T));return t||this.#S[0]}#Z(){if(this.#I)return LitHtml.html`
        <${ExtensionView.litTagName} .descriptor=${this.#I}>
        </${ExtensionView.litTagName}>
      `;const t=this.#Y(),e=t?.getFormatName();return this.#y?LitHtml.html`
        <${SplitView.SplitView.SplitView.litTagName}>
          <div slot="main">
            ${this.#tt()}
          </div>
          <div slot="sidebar">
            <div class="section-toolbar">
              <${Menus.SelectMenu.SelectMenu.litTagName}
                @selectmenuselected=${this.#et}
                .showDivider=${!0}
                .showArrow=${!0}
                .sideButton=${!1}
                .showSelectedItem=${!0}
                .showConnector=${!1}
                .position=${"bottom"}
                .buttonTitle=${e}
              >
                ${this.#S.map((t=>LitHtml.html`<${Menus.Menu.MenuItem.litTagName}
                    .value=${t.getId()}
                    .selected=${this.#T===t.getId()}
                  >
                    ${t.getFormatName()}
                  </${Menus.Menu.MenuItem.litTagName}>`))}
                ${this.#w.map((t=>LitHtml.html`<${Menus.Menu.MenuItem.litTagName}
                    .value=${t.getId()}
                    .selected=${this.#T===t.getId()}
                  >
                    ${t.getFormatName()}
                  </${Menus.Menu.MenuItem.litTagName}>`))}
              </${Menus.SelectMenu.SelectMenu.litTagName}>
              <${Buttons.Button.Button.litTagName}
                title=${Models.Tooltip.getTooltipForActions(i18nString(UIStrings.hideCode),"chrome_recorder.toggle-code-view")}
                .data=${{variant:"round",size:"SMALL",iconName:"cross"}}
                @click=${this.showCodeToggle}
              ></${Buttons.Button.Button.litTagName}>
            </div>
            <div class="text-editor">
              <${TextEditor.TextEditor.TextEditor.litTagName} .state=${this.#f}></${TextEditor.TextEditor.TextEditor.litTagName}>
            </div>
          </div>
        </${SplitView.SplitView.SplitView.litTagName}>
      `:this.#tt()}#it(t){return t.screenshot?LitHtml.html`
      <img class="screenshot" src=${t.screenshot} alt=${i18nString(UIStrings.screenshotForSection)} />
    `:null}#nt(){return this.#e.isPlaying?LitHtml.html`
        <${Buttons.Button.Button.litTagName} @click=${this.#k} .iconName=${"pause"} .variant=${"secondary"}>
          ${i18nString(UIStrings.cancelReplay)}
        </${Buttons.Button.Button.litTagName}>`:LitHtml.html`<${ReplayButton.litTagName}
        .data=${{settings:this.#p,replayExtensions:this.#C}}
        .disabled=${this.#e.isPlaying}
        @startreplay=${this.#B}
        >
      </${ReplayButton.litTagName}>`}#st(t){t.stopPropagation(),this.dispatchEvent(new PlayRecordingEvent({targetPanel:"timeline",speed:"normal"}))}showCodeToggle=()=>{this.#y=!this.#y,Host.userMetrics.recordingCodeToggled(this.#y?Host.UserMetrics.RecordingCodeToggled.CodeShown:Host.UserMetrics.RecordingCodeToggled.CodeHidden),this.#N()};#N=async()=>{if(!this.#i)return;const t=this.#Y();if(!t)return;const[e,i]=await t.stringify(this.#i);this.#$=e,this.#b=i,this.#b?.shift();const n=t.getMediaType(),s=n?await CodeHighlighter.CodeHighlighter.languageFromMIME(n):null;this.#f=CodeMirror.EditorState.create({doc:this.#$,extensions:[TextEditor.Config.baseConfiguration(this.#$),CodeMirror.EditorState.readOnly.of(!0),CodeMirror.EditorView.lineWrapping,s||[]]}),this.#M(),this.dispatchEvent(new Event("code-generated"))};#D=(t,e=!1)=>{if(!this.#b)return;const i=this.#a.indexOf(t);if(-1===i)return;const n=this.#t.querySelector("devtools-text-editor");if(!n)return;const s=n.editor;if(!s)return;const o=this.#b[2*i],r=this.#b[2*i+1];let a=n.createSelection({lineNumber:o+r,columnNumber:0},{lineNumber:o,columnNumber:0});const l=n.state.doc.lineAt(a.main.anchor);a=n.createSelection({lineNumber:o+r-1,columnNumber:l.length+1},{lineNumber:o,columnNumber:0}),s.dispatch({selection:a,effects:e?[CodeMirror.EditorView.scrollIntoView(a.main,{y:"nearest"})]:void 0})};#et=t=>{this.#T=t.itemValue,this.#p&&(this.#p.preferredCopyFormat=t.itemValue),this.#N()};#tt(){return LitHtml.html`
      <div class="sections">
      ${this.#y?"":LitHtml.html`<div class="section-toolbar">
        <${Buttons.Button.Button.litTagName}
          @click=${this.showCodeToggle}
          class="show-code"
          .data=${{variant:"secondary",title:Models.Tooltip.getTooltipForActions(i18nString(UIStrings.showCode),"chrome_recorder.toggle-code-view")}}
        >
          ${i18nString(UIStrings.showCode)}
        </${Buttons.Button.Button.litTagName}>
      </div>`}
      ${this.#d.map(((t,e)=>LitHtml.html`
            <div class="section">
              <div class="screenshot-wrapper">
                ${this.#it(t)}
              </div>
              <div class="content">
                <div class="steps">
                  <${StepView.litTagName}
                    @click=${this.#U}
                    @mouseover=${this.#V}
                    .data=${{section:t,state:this.#P(t),isStartOfGroup:!0,isEndOfGroup:0===t.steps.length,isFirstSection:0===e,isLastSection:e===this.#d.length-1&&0===t.steps.length,isSelected:this.#u===(t.causingStep||null),sectionIndex:e,isRecording:this.#n,isPlaying:this.#e.isPlaying,error:"error"===this.#P(t)?this.#l:void 0,hasBreakpoint:!1,removable:this.#a.length>1&&t.causingStep}}
                  >
                  </${StepView.litTagName}>
                  ${t.steps.map((i=>this.#F(t,i,e===this.#d.length-1)))}
                  ${!this.#s&&this.#n&&e===this.#d.length-1?LitHtml.html`<devtools-button
                    class="step add-assertion-button"
                    .data=${{variant:"secondary",title:i18nString(UIStrings.addAssertion)}}
                    @click=${this.#R}
                  >${i18nString(UIStrings.addAssertion)}</devtools-button>`:void 0}
                  ${this.#n&&e===this.#d.length-1?LitHtml.html`<div class="step recording">${i18nString(UIStrings.recording)}</div>`:null}
                </div>
              </div>
            </div>
      `))}
      </div>
    `}#ot(){if(!this.#i)return"";const{title:t}=this.#i,e=!this.#e.isPlaying&&!this.#n;return LitHtml.html`
      <div class="header">
        <div class="header-title-wrapper">
          <div class="header-title">
            <span @blur=${this.#q}
                  @keydown=${this.#G}
                  id="title-input"
                  .contentEditable=${e?"true":"false"}
                  class=${LitHtml.Directives.classMap({"has-error":this.#o,disabled:!e})}
                  .innerText=${LitHtml.Directives.live(t)}></span>
            <div class="title-button-bar">
              <${Buttons.Button.Button.litTagName}
                @click=${this.#z}
                .data=${{disabled:!e,variant:"toolbar",iconName:"edit",title:i18nString(UIStrings.editTitle)}}
              ></${Buttons.Button.Button.litTagName}>
            </div>
          </div>
          ${this.#o?LitHtml.html`<div class="title-input-error-text">
            ${i18nString(UIStrings.requiredTitleError)}
          </div>`:""}
        </div>
        ${!this.#n&&this.#v?LitHtml.html`<div class="actions">
                <${Buttons.Button.Button.litTagName}
                  @click=${this.#st}
                  .data=${{disabled:this.#e.isPlaying,variant:"secondary",iconName:"performance",title:i18nString(UIStrings.performancePanel)}}
                >
                  ${i18nString(UIStrings.performancePanel)}
                </${Buttons.Button.Button.litTagName}>
                ${this.#nt()}
              </div>`:""}
      </div>`}#rt(){if(!this.#n)return"";const t=this.#s?i18nString(UIStrings.recordingIsBeingStopped):i18nString(UIStrings.endRecording);return LitHtml.html`
      <div class="footer">
        <div class="controls">
          <devtools-control-button
            @click=${this.#H}
            .disabled=${this.#s}
            .shape=${"square"}
            .label=${t}
            title=${Models.Tooltip.getTooltipForActions(t,"chrome_recorder.start-recording")}
          >
          </devtools-control-button>
        </div>
      </div>
    `}#M(){const t={wrapper:!0,"is-recording":this.#n,"is-playing":this.#e.isPlaying,"was-successful":"Success"===this.#h,"was-failure":"Failure"===this.#h};LitHtml.render(LitHtml.html`
      <div @click=${this.#j} class=${LitHtml.Directives.classMap(t)}>
        <div class="main">
          ${this.#ot()}
          ${this.#I?LitHtml.html`
            <${ExtensionView.litTagName} .descriptor=${this.#I}>
            </${ExtensionView.litTagName}>
          `:LitHtml.html`
            ${this.#X()}
            ${this.#Z()}
          `}
          ${this.#rt()}
        </div>
      </div>
    `,this.#t,{host:this})}}ComponentHelpers.CustomElements.defineComponent("devtools-recording-view",RecordingView);