import*as Host from"../../../core/host/host.js";import*as Platform from"../../../core/platform/platform.js";import*as UI from"../../legacy/legacy.js";import*as LitHtml from"../../lit-html/lit-html.js";import*as ComponentHelpers from"../helpers/helpers.js";import*as Coordinator from"../render_coordinator/render_coordinator.js";import dataGridStyles from"./dataGrid.css.js";import{BodyCellFocusedEvent,ColumnHeaderClickEvent,ContextMenuHeaderResetClickEvent}from"./DataGridEvents.js";const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();import{addColumnVisibilityCheckboxes,addSortableColumnItems}from"./DataGridContextMenuUtils.js";import{calculateColumnWidthPercentageFromWeighting,calculateFirstFocusableCell,getCellTitleFromCellContent,getRowEntryForColumnId,handleArrowKeyNavigation,renderCellValue}from"./DataGridUtils.js";import*as i18n from"../../../core/i18n/i18n.js";const UIStrings={sortBy:"Sort By",resetColumns:"Reset Columns",headerOptions:"Header Options",enterToSort:"Column sort state: {PH1}. Press enter to apply sorting filter",sortAsc:"ascending",sortDesc:"descending",sortNone:"none"},str_=i18n.i18n.registerUIStrings("ui/components/data_grid/DataGrid.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),KEYS_TREATED_AS_CLICKS=new Set([" ","Enter"]),ROW_HEIGHT_PIXELS=18;export class DataGrid extends HTMLElement{static litTagName=LitHtml.literal`devtools-data-grid`;#e=this.attachShadow({mode:"open"});#t=[];#s=[];#i=null;#r=!1;#o="NOT_SCROLLED";#n=void 0;#l=void 0;#a=10;#c=!1;#d=!1;#h=null;#u=new WeakMap;#m=new ResizeObserver((()=>{this.#C()}));#g=this.#p.bind(this);#f=[0,1];#w=null;#b=!1;#S=!1;#R=!1;connectedCallback(){this.#e.adoptedStyleSheets=[dataGridStyles],ComponentHelpers.SetCSSProperty.set(this,"--table-row-height","18px")}get data(){return{columns:this.#t,rows:this.#s,activeSort:this.#i,contextMenus:this.#n,label:this.#l,paddingRowsCount:this.#a,showScrollbar:this.#c,striped:this.#d}}set data(e){if(this.#t=e.columns,this.#s=e.rows,this.#s.forEach(((e,t)=>{this.#u.set(e,t)})),this.#i=e.activeSort,this.#n=e.contextMenus,this.#l=e.label,this.#c=e.showScrollbar,this.#d=e.striped,this.#b||(this.#f=calculateFirstFocusableCell({columns:this.#t,rows:this.#s})),void 0!==e.paddingRowsCount&&(this.#a=e.paddingRowsCount),this.#b&&this.#H()){const[e,t]=this.#I(),s=e>this.#t.length,i=t>this.#s.length;(s||i)&&(this.#w=[s?this.#t.length:e,i?this.#s.length:t])}this.#v()}#y(){return"SCROLLED_TO_BOTTOM"===this.#o||!this.#S&&"MANUAL_SCROLL_NOT_BOTTOM"!==this.#o}#x(){if(!1===this.#b||!this.#y())return;const e=this.#e.querySelector(".wrapping-container");e&&coordinator.scroll((()=>{const t=e.scrollHeight;e.scrollTo(0,t)}))}#M(){this.#b||this.#m.observe(this.#e.host)}#H(){return null!==this.#w}#L(){if(!this.#w)return null;const[e,t]=this.#w;return this.#e.querySelector(`[data-row-index="${t}"][data-col-index="${e}"]`)}#F(e){e.focus()}#$([e,t]){if(this.#S=!0,this.#w&&this.#w[0]===e&&this.#w[1]===t)return;this.#w=[e,t],this.#v();const s=this.#L();if(s&&(this.#F(s),0===t&&this.#t[e].sortable)){const t=this.#D(this.#t[e]);UI.ARIAUtils.alert(i18nString(UIStrings.enterToSort,{PH1:t||""}))}}#D(e){switch(this.#T(e)){case"ascending":return UIStrings.sortAsc;case"descending":return UIStrings.sortDesc;case"none":return UIStrings.sortNone}}#U(e){const t=e.key;if(!this.#w)return;if(KEYS_TREATED_AS_CLICKS.has(t)){const[e,t]=this.#w,s=this.#t[e];0===t&&s&&s.sortable&&this.#O(s,e)}if(!Platform.KeyboardUtilities.keyIsArrowKey(t))return;const s=handleArrowKeyNavigation({key:t,currentFocusedCell:this.#w,columns:this.#t,rows:this.#s});e.preventDefault(),this.#$(s)}#O(e,t){this.dispatchEvent(new ColumnHeaderClickEvent(e,t))}#T(e){return!e.sortable||this.#i&&this.#i.columnId===e.id?this.#i&&this.#i.columnId===e.id?"ASC"===this.#i.direction?"ascending":"descending":void 0:"none"}#z(e){const t=this.#t.map(((e,t)=>{if(!e.visible)return LitHtml.nothing;const s=LitHtml.Directives.classMap({firstVisibleColumn:0===t});return LitHtml.html`<td aria-hidden="true" class=${s} data-filler-row-column-index=${t}></td>`})),s=LitHtml.Directives.classMap({"filler-row":!0,"padding-row":!0,"empty-table":0===e});return LitHtml.html`<tr aria-hidden="true" class=${s}>${t}</tr>`}#E(){this.#h&&(this.#h.documentForCursorChange.body.style.cursor=this.#h.cursorToRestore,this.#h=null,this.#C())}#P(e){if(1!==e.buttons||Host.Platform.isMac()&&e.ctrlKey)return;e.preventDefault();const t=e.target;if(!t)return;const s=t.dataset.columnIndex;if(!s)return;const i=globalThis.parseInt(s,10),r=this.#t.findIndex(((e,t)=>t>i&&!0===e.visible)),o=this.#e.querySelector(`td[data-filler-row-column-index="${i}"]`),n=this.#e.querySelector(`td[data-filler-row-column-index="${r}"]`);if(!o||!n)return;const l=this.#e.querySelector(`col[data-col-column-index="${i}"]`),a=this.#e.querySelector(`col[data-col-column-index="${r}"]`);if(!l||!a)return;const c=e.target.ownerDocument;c&&(this.#h={leftCellCol:l,rightCellCol:a,leftCellColInitialPercentageWidth:globalThis.parseInt(l.style.width,10),rightCellColInitialPercentageWidth:globalThis.parseInt(a.style.width,10),initialLeftCellWidth:o.clientWidth,initialRightCellWidth:n.clientWidth,initialMouseX:e.x,documentForCursorChange:c,cursorToRestore:t.style.cursor},c.body.style.cursor="col-resize",t.setPointerCapture(e.pointerId),t.addEventListener("pointermove",this.#g))}#p(e){if(e.preventDefault(),!this.#h)return;const t=this.#h.leftCellColInitialPercentageWidth+this.#h.rightCellColInitialPercentageWidth-10,s=e.x-this.#h.initialMouseX,i=Math.abs(s)/(this.#h.initialLeftCellWidth+this.#h.initialRightCellWidth)*100;let r,o;s>0?(r=Platform.NumberUtilities.clamp(this.#h.leftCellColInitialPercentageWidth+i,10,t),o=Platform.NumberUtilities.clamp(this.#h.rightCellColInitialPercentageWidth-i,10,t)):s<0&&(r=Platform.NumberUtilities.clamp(this.#h.leftCellColInitialPercentageWidth-i,10,t),o=Platform.NumberUtilities.clamp(this.#h.rightCellColInitialPercentageWidth+i,10,t)),r&&o&&(this.#h.leftCellCol.style.width=r.toFixed(2)+"%",this.#h.rightCellCol.style.width=o.toFixed(2)+"%")}#A(e){e.preventDefault();const t=e.target;t&&(t.releasePointerCapture(e.pointerId),t.removeEventListener("pointermove",this.#g),this.#E())}#_(e,t){const[s]=t;return s!==this.#W()&&e.visible?LitHtml.html`<span class="cell-resize-handle"
     @pointerdown=${this.#P}
     @pointerup=${this.#A}
     data-column-index=${s}
    ></span>`:LitHtml.nothing}#W(){let e=this.#t.length-1;for(;e>-1;e--){if(this.#t[e].visible)break}return e}#k(e){if(2!==e.button&&-1!==e.button)return;const t=new UI.ContextMenu.ContextMenu(e);addColumnVisibilityCheckboxes(this,t);const s=t.defaultSection().appendSubMenuItem(i18nString(UIStrings.sortBy));addSortableColumnItems(this,s),t.defaultSection().appendItem(i18nString(UIStrings.resetColumns),(()=>{this.dispatchEvent(new ContextMenuHeaderResetClickEvent)})),this.#n&&this.#n.headerRow&&this.#n.headerRow(t,this.#t),t.show()}#B(e){if(2!==e.button&&-1!==e.button)return;if(!(e.target&&e.target instanceof HTMLElement))return;const t=e.target.dataset.rowIndex;if(!t)return;const s=parseInt(t,10),i=this.#s[s-1],r=new UI.ContextMenu.ContextMenu(e),o=r.defaultSection().appendSubMenuItem(i18nString(UIStrings.sortBy));addSortableColumnItems(this,o);const n=r.defaultSection().appendSubMenuItem(i18nString(UIStrings.headerOptions));addColumnVisibilityCheckboxes(this,n),n.defaultSection().appendItem(i18nString(UIStrings.resetColumns),(()=>{this.dispatchEvent(new ContextMenuHeaderResetClickEvent)})),this.#n&&this.#n.bodyRow&&this.#n.bodyRow(r,this.#t,i),r.show()}#q(e){const t=e.target;if(!t)return;const s=Math.round(t.scrollTop+t.clientHeight)===Math.round(t.scrollHeight);this.#o=s?"SCROLLED_TO_BOTTOM":"MANUAL_SCROLL_NOT_BOTTOM",this.#v()}#C(){return coordinator.read((()=>{const e=this.#e.querySelectorAll("th:not(.hidden)"),t=this.#e.querySelectorAll(".cell-resize-handle");this.#e.querySelector("table")&&e.forEach((async(e,s)=>{const i=e.clientWidth,r=e.offsetLeft;if(t[s]){const e=t[s].clientWidth;coordinator.write((()=>{t[s].style.left=r+i-e+"px"}))}}))}))}#G(){return coordinator.read((()=>{const e=this.#e.querySelector(".wrapping-container");let t=0,s=window.innerHeight;e&&(t=e.scrollTop,s=e.clientHeight);const i=18*this.#a;let r=Math.floor((t-i)/18),o=Math.ceil((t+s+i)/18);return r=Math.max(0,r),o=Math.min(this.#s.filter((e=>!e.hidden)).length,o),{topVisibleRow:r,bottomVisibleRow:o}}))}#N(){this.#S=!1}#I(){return this.#w||this.#f}async#v(){if(this.#r)return void(this.#R=!0);this.#r=!0;const{topVisibleRow:e,bottomVisibleRow:t}=await this.#G(),s=this.#s.filter((e=>!e.hidden)),i=s.filter(((s,i)=>i>=e&&i<=t)),r=this.#t.findIndex((e=>e.visible)),o=this.#t.some((e=>!0===e.sortable)),n={"wrapping-container":!0,"show-scrollbar":!0===this.#c,striped:!0===this.#d};await coordinator.write((()=>{LitHtml.render(LitHtml.html`
      ${this.#t.map(((e,t)=>this.#_(e,[t,0])))}
      <div class=${LitHtml.Directives.classMap(n)} @scroll=${this.#q} @focusout=${this.#N}>
        <table
          aria-label=${LitHtml.Directives.ifDefined(this.#l)}
          aria-rowcount=${this.#s.length}
          aria-colcount=${this.#t.length}
          @keydown=${this.#U}
        >
          <colgroup>
            ${this.#t.map(((e,t)=>{const s=`width: ${calculateColumnWidthPercentageFromWeighting(this.#t,e.id)}%`;return e.visible?LitHtml.html`<col style=${s} data-col-column-index=${t}>`:LitHtml.nothing}))}
          </colgroup>
          <thead>
            <tr @contextmenu=${this.#k}>
              ${this.#t.map(((e,t)=>{const s=LitHtml.Directives.classMap({hidden:!e.visible,firstVisibleColumn:t===r,sortable:o}),i=this.#I(),n=o&&t===i[0]&&0===i[1];return LitHtml.html`<th class=${s}
                  style=${LitHtml.Directives.ifDefined(e.styles?LitHtml.Directives.styleMap(e.styles):void 0)}
                  data-grid-header-cell=${e.id}
                  @focus=${()=>{this.#$([t,0])}}
                  @click=${()=>{this.#O(e,t)}}
                  title=${e.title}
                  aria-sort=${LitHtml.Directives.ifDefined(this.#T(e))}
                  aria-colindex=${t+1}
                  data-row-index='0'
                  data-col-index=${t}
                  tabindex=${LitHtml.Directives.ifDefined(o?n?"0":"-1":void 0)}
                >${e.titleElement||e.title}</th>`}))}
            </tr>
          </thead>
          <tbody>
            <tr class="filler-row-top padding-row" style=${LitHtml.Directives.styleMap({height:18*e+"px"})} aria-hidden="true"></tr>
            ${LitHtml.Directives.repeat(i,(e=>this.#u.get(e)),(e=>{const t=this.#u.get(e);if(void 0===t)throw new Error("Trying to render a row that has no index in the rowIndexMap");const s=this.#I(),i=t+1,o=!!this.#w&&i===this.#w[1],n=LitHtml.Directives.classMap({selected:o,hidden:!0===e.hidden});return LitHtml.html`
                <tr
                  aria-rowindex=${t+1}
                  class=${n}
                  style=${LitHtml.Directives.ifDefined(e.styles?LitHtml.Directives.styleMap(e.styles):void 0)}
                  @contextmenu=${this.#B}
                >${this.#t.map(((t,o)=>{const n=getRowEntryForColumnId(e,t.id),l=LitHtml.Directives.classMap({hidden:!t.visible,firstVisibleColumn:o===r}),a=o===s[0]&&i===s[1],c=t.visible?renderCellValue(n):null;return LitHtml.html`<td
                    class=${l}
                    style=${LitHtml.Directives.ifDefined(t.styles?LitHtml.Directives.styleMap(t.styles):void 0)}
                    tabindex=${a?"0":"-1"}
                    aria-colindex=${o+1}
                    title=${n.title||getCellTitleFromCellContent(String(n.value))}
                    data-row-index=${i}
                    data-col-index=${o}
                    data-grid-value-cell-for-column=${t.id}
                    @focus=${()=>{this.#$([o,i]),this.dispatchEvent(new BodyCellFocusedEvent(n,e))}}
                  >${c}</td>`}))}
              `}))}
            ${this.#z(i.length)}
            <tr class="filler-row-bottom padding-row" style=${LitHtml.Directives.styleMap({height:18*Math.max(0,s.length-t)+"px"})} aria-hidden="true"></tr>
          </tbody>
        </table>
      </div>
      `,this.#e,{host:this})}));const l=this.#I()[1],a=this.#L();this.#S&&l>0&&a&&this.#F(a),this.#x(),this.#M(),this.#b&&this.#C(),this.#r=!1,this.#b=!0,this.#R&&(this.#R=!1,this.#v())}}ComponentHelpers.CustomElements.defineComponent("devtools-data-grid",DataGrid);