import*as i18n from"../../core/i18n/i18n.js";import{Issue,IssueCategory,IssueKind}from"./Issue.js";const UIStrings={corsPrivateNetworkAccess:"Private Network Access",CORS:"Cross-Origin Resource Sharing (`CORS`)"},str_=i18n.i18n.registerUIStrings("models/issues_manager/CorsIssue.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export var IssueCode;function getIssueCode(e){switch(e.corsErrorStatus.corsError){case"InvalidAllowMethodsPreflightResponse":case"InvalidAllowHeadersPreflightResponse":case"PreflightMissingAllowOriginHeader":case"PreflightMultipleAllowOriginValues":case"PreflightInvalidAllowOriginValue":case"MissingAllowOriginHeader":case"MultipleAllowOriginValues":case"InvalidAllowOriginValue":return IssueCode.InvalidHeaderValues;case"PreflightWildcardOriginNotAllowed":case"WildcardOriginNotAllowed":return IssueCode.WildcardOriginNotAllowed;case"PreflightInvalidStatus":case"PreflightDisallowedRedirect":case"InvalidResponse":return IssueCode.PreflightResponseInvalid;case"AllowOriginMismatch":case"PreflightAllowOriginMismatch":return IssueCode.OriginMismatch;case"InvalidAllowCredentials":case"PreflightInvalidAllowCredentials":return IssueCode.AllowCredentialsRequired;case"MethodDisallowedByPreflightResponse":return IssueCode.MethodDisallowedByPreflightResponse;case"HeaderDisallowedByPreflightResponse":return IssueCode.HeaderDisallowedByPreflightResponse;case"RedirectContainsCredentials":return IssueCode.RedirectContainsCredentials;case"DisallowedByMode":return IssueCode.DisallowedByMode;case"CorsDisabledScheme":return IssueCode.CorsDisabledScheme;case"PreflightMissingAllowExternal":return IssueCode.PreflightMissingAllowExternal;case"PreflightInvalidAllowExternal":return IssueCode.PreflightInvalidAllowExternal;case"InsecurePrivateNetwork":return IssueCode.InsecurePrivateNetwork;case"NoCorsRedirectModeNotFollow":return IssueCode.NoCorsRedirectModeNotFollow;case"InvalidPrivateNetworkAccess":return IssueCode.InvalidPrivateNetworkAccess;case"UnexpectedPrivateNetworkAccess":return IssueCode.UnexpectedPrivateNetworkAccess;case"PreflightMissingAllowPrivateNetwork":case"PreflightInvalidAllowPrivateNetwork":return IssueCode.PreflightAllowPrivateNetworkError;case"PreflightMissingPrivateNetworkAccessId":return IssueCode.PreflightMissingPrivateNetworkAccessId;case"PreflightMissingPrivateNetworkAccessName":return IssueCode.PreflightMissingPrivateNetworkAccessName;case"PrivateNetworkAccessPermissionUnavailable":return IssueCode.PrivateNetworkAccessPermissionUnavailable;case"PrivateNetworkAccessPermissionDenied":return IssueCode.PrivateNetworkAccessPermissionDenied}}!function(e){e.InsecurePrivateNetwork="CorsIssue::InsecurePrivateNetwork",e.InvalidHeaderValues="CorsIssue::InvalidHeaders",e.WildcardOriginNotAllowed="CorsIssue::WildcardOriginWithCredentials",e.PreflightResponseInvalid="CorsIssue::PreflightResponseInvalid",e.OriginMismatch="CorsIssue::OriginMismatch",e.AllowCredentialsRequired="CorsIssue::AllowCredentialsRequired",e.MethodDisallowedByPreflightResponse="CorsIssue::MethodDisallowedByPreflightResponse",e.HeaderDisallowedByPreflightResponse="CorsIssue::HeaderDisallowedByPreflightResponse",e.RedirectContainsCredentials="CorsIssue::RedirectContainsCredentials",e.DisallowedByMode="CorsIssue::DisallowedByMode",e.CorsDisabledScheme="CorsIssue::CorsDisabledScheme",e.PreflightMissingAllowExternal="CorsIssue::PreflightMissingAllowExternal",e.PreflightInvalidAllowExternal="CorsIssue::PreflightInvalidAllowExternal",e.NoCorsRedirectModeNotFollow="CorsIssue::NoCorsRedirectModeNotFollow",e.InvalidPrivateNetworkAccess="CorsIssue::InvalidPrivateNetworkAccess",e.UnexpectedPrivateNetworkAccess="CorsIssue::UnexpectedPrivateNetworkAccess",e.PreflightAllowPrivateNetworkError="CorsIssue::PreflightAllowPrivateNetworkError",e.PreflightMissingPrivateNetworkAccessId="CorsIssue::PreflightMissingPrivateNetworkAccessId",e.PreflightMissingPrivateNetworkAccessName="CorsIssue::PreflightMissingPrivateNetworkAccessName",e.PrivateNetworkAccessPermissionUnavailable="CorsIssue::PrivateNetworkAccessPermissionUnavailable",e.PrivateNetworkAccessPermissionDenied="CorsIssue::PrivateNetworkAccessPermissionDenied"}(IssueCode||(IssueCode={}));export class CorsIssue extends Issue{#e;constructor(e,s,r){super(getIssueCode(e),s,r),this.#e=e}getCategory(){return IssueCategory.Cors}details(){return this.#e}getDescription(){switch(getIssueCode(this.#e)){case IssueCode.InsecurePrivateNetwork:return{file:"corsInsecurePrivateNetwork.md",links:[{link:"https://developer.chrome.com/blog/private-network-access-update",linkTitle:i18nString(UIStrings.corsPrivateNetworkAccess)}]};case IssueCode.PreflightAllowPrivateNetworkError:return{file:"corsPreflightAllowPrivateNetworkError.md",links:[{link:"https://developer.chrome.com/blog/private-network-access-update",linkTitle:i18nString(UIStrings.corsPrivateNetworkAccess)}]};case IssueCode.InvalidHeaderValues:return{file:"corsInvalidHeaderValues.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.WildcardOriginNotAllowed:return{file:"corsWildcardOriginNotAllowed.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.PreflightResponseInvalid:return{file:"corsPreflightResponseInvalid.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.OriginMismatch:return{file:"corsOriginMismatch.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.AllowCredentialsRequired:return{file:"corsAllowCredentialsRequired.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.MethodDisallowedByPreflightResponse:return{file:"corsMethodDisallowedByPreflightResponse.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.HeaderDisallowedByPreflightResponse:return{file:"corsHeaderDisallowedByPreflightResponse.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.RedirectContainsCredentials:return{file:"corsRedirectContainsCredentials.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.DisallowedByMode:return{file:"corsDisallowedByMode.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.CorsDisabledScheme:return{file:"corsDisabledScheme.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.NoCorsRedirectModeNotFollow:return{file:"corsNoCorsRedirectModeNotFollow.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:i18nString(UIStrings.CORS)}]};case IssueCode.PreflightMissingPrivateNetworkAccessId:case IssueCode.PreflightMissingPrivateNetworkAccessName:return{file:"corsPrivateNetworkPermissionDenied.md",links:[{link:"https://developer.chrome.com/blog/private-network-access-update",linkTitle:i18nString(UIStrings.corsPrivateNetworkAccess)}]};case IssueCode.PreflightMissingAllowExternal:case IssueCode.PreflightInvalidAllowExternal:case IssueCode.InvalidPrivateNetworkAccess:case IssueCode.UnexpectedPrivateNetworkAccess:case IssueCode.PrivateNetworkAccessPermissionUnavailable:case IssueCode.PrivateNetworkAccessPermissionDenied:return null}}primaryKey(){return JSON.stringify(this.#e)}getKind(){return!this.#e.isWarning||"InsecurePrivateNetwork"!==this.#e.corsErrorStatus.corsError&&"PreflightMissingAllowPrivateNetwork"!==this.#e.corsErrorStatus.corsError&&"PreflightInvalidAllowPrivateNetwork"!==this.#e.corsErrorStatus.corsError?IssueKind.PageError:IssueKind.BreakingChange}static fromInspectorIssue(e,s){const r=s.details.corsIssueDetails;return r?[new CorsIssue(r,e,s.issueId)]:(console.warn("Cors issue without details received."),[])}}