const styles=new CSSStyleSheet;styles.replaceSync("/*\n * Copyright 2023 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n* {\n  margin: 0;\n  padding: 0;\n  box-sizing: border-box;\n  font-size: inherit;\n}\n\n.timeline-section {\n  position: relative;\n  padding: 16px 0 16px 40px;\n  margin-left: 8px;\n\n  --override-color-recording-successful-text: #36a854;\n  --override-color-recording-successful-background: #e6f4ea;\n}\n\n.overlay {\n  position: absolute;\n  width: 100vw;\n  height: 100%;\n  /* Offset of 32px for spacing and 80px for screenshot */\n  left: calc(-32px - 80px);\n  top: 0;\n  z-index: -1;\n  pointer-events: none;\n}\n\n/* stylelint-disable-next-line at-rule-no-unknown */\n@container (max-width: 400px) {\n  .overlay {\n    /* Offset of 32px for spacing */\n    left: -32px;\n  }\n}\n\n:hover .overlay {\n  background: var(--sys-color-state-hover-on-subtle);\n}\n\n.is-selected .overlay {\n  background: var(--sys-color-tonal-container);\n}\n\n:host-context(.is-stopped) .overlay {\n  background: var(--sys-color-state-ripple-primary);\n  outline: 1px solid var(--sys-color-state-focus-ring);\n  z-index: 4;\n}\n\n.is-start-of-group {\n  padding-top: 28px;\n}\n\n.is-end-of-group {\n  padding-bottom: 24px;\n}\n\n.icon {\n  position: absolute;\n  left: 4px;\n  transform: translateX(-50%);\n  z-index: 2;\n}\n\n.bar {\n  position: absolute;\n  left: 4px;\n  display: block;\n  transform: translateX(-50%);\n  top: 18px;\n  height: calc(100% + 8px);\n  z-index: 1; /* We want this to be below of \\'.overlay\\' for stopped case */\n}\n\n.bar .background {\n  fill: var(--sys-color-state-hover-on-subtle);\n}\n\n.bar .line {\n  fill: var(--sys-color-primary);\n}\n\n.is-first-section .bar {\n  top: 32px;\n  height: calc(100% - 8px);\n  display: none;\n}\n\n.is-first-section:not(.is-last-section) .bar {\n  display: block;\n}\n\n.is-last-section .bar .line {\n  display: none;\n}\n\n.is-last-section .bar .background {\n  display: none;\n}\n\n:host-context(.is-error) .bar .line {\n  fill: var(--sys-color-error);\n}\n\n:host-context(.is-error) .bar .background {\n  fill: var(--sys-color-error-container);\n}\n\n:host-context(.was-successful) .bar .background {\n  animation: flash-background 2s;\n}\n\n:host-context(.was-successful) .bar .line {\n  animation: flash-line 2s;\n}\n\n@keyframes flash-background {\n  25% {\n    fill: var(--override-color-recording-successful-background);\n  }\n\n  75% {\n    fill: var(--override-color-recording-successful-background);\n  }\n}\n\n@keyframes flash-line {\n  25% {\n    fill: var(--override-color-recording-successful-text);\n  }\n\n  75% {\n    fill: var(--override-color-recording-successful-text);\n  }\n}\n\n/*# sourceURL=timelineSection.css */\n");export default styles;