const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright 2022 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n:host {\n  flex: auto;\n  display: flex;\n  flex-direction: column;\n}\n\n.code-snippet {\n  width: 100%;\n  font-family: var(--source-code-font-family);\n  font-size: var(--source-code-font-size);\n  color: var(--color-text-secondary);\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n  flex-shrink: 100;\n  cursor: pointer;\n}\n\n.code-snippet:hover {\n  color: var(--color-text-primary);\n  text-decoration: underline;\n}\n\ninput {\n  height: 12px;\n  width: 12px;\n  flex-shrink: 0;\n  margin: 3px 0;\n}\n\ndetails {\n  border-top: 1px solid var(--sys-color-divider);\n}\n\ndetails:not(.active) {\n  background-color: var(--color-background-elevation-1);\n  opacity: 30%;\n}\n\ndetails > summary {\n  height: 18px;\n  list-style: none;\n  display: flex;\n  padding: 0 8px 0 6px;\n  align-items: center;\n}\n\ndetails > summary:hover {\n  background-color: var(--color-background-elevation-1);\n}\n\ndetails > summary::before {\n  display: block;\n  user-select: none;\n  -webkit-mask-image: var(--image-file-triangle-right);\n  background-color: var(--icon-default);\n  content: "";\n  height: 14px;\n  min-width: 14px;\n  max-width: 14px;\n  margin-left: -4px;\n  overflow: hidden;\n  transition: transform 200ms;\n}\n\ndetails[open] > summary::before {\n  transform: rotate(90deg);\n}\n\n.group-header {\n  display: inline-flex;\n  align-items: center;\n  width: 100%;\n  padding-right: 8px;\n  overflow: hidden;\n}\n\n.group-icon-or-disable {\n  justify-content: center;\n  display: flex;\n  width: 16px;\n  margin-left: 2px;\n}\n\n.group-header-title {\n  margin-left: 4px;\n  font-weight: 500;\n  font-size: var(--source-code-font-size);\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n}\n\n.group-header-differentiator {\n  font-weight: normal;\n  color: var(--color-text-disabled);\n  margin-left: 8px;\n}\n\n.group-hover-actions {\n  display: flex;\n  align-items: center;\n  justify-content: right;\n  font-size: 10px;\n  font-weight: 500;\n}\n\n.breakpoint-item-location-or-actions {\n  min-width: 20px;\n  flex: 0 0 auto;\n  display: flex;\n  padding-left: 8px;\n  justify-content: right;\n}\n\nbutton {\n  cursor: pointer;\n  width: 13px;\n  height: 13px;\n  border: none;\n  background-color: transparent;\n  display: none;\n  align-items: center;\n  justify-content: center;\n}\n\nbutton + span {\n  padding-left: 6px;\n}\n\nbutton + button {\n  padding-left: 11px;\n}\n\nsummary:hover button {\n  display: flex;\n}\n\nbutton:hover devtools-icon {\n  --icon-color: var(--icon-default-hover);\n}\n\n.type-indicator {\n  --override-color-conditional-breakpoint: #f29900;\n  --override-color-logpoint: #f439a0;\n\n  border-right: 4px solid;\n  border-radius: 0 2px 2px 0;\n  border-color: transparent;\n  height: 16px;\n}\n\n.breakpoint-item {\n  display: flex;\n  align-items: center;\n  line-height: 13px;\n  height: 20px;\n  padding-right: 8px;\n}\n\n.breakpoint-item:hover {\n  background-color: var(--color-background-elevation-1);\n}\n\n.breakpoint-item.hit {\n  --override-breakpoint-hit-background: rgb(255 255 194);\n\n  background-color: var(--override-breakpoint-hit-background);\n}\n\n.breakpoint-item.hit:focus {\n  background-color: var(--legacy-focus-bg-color);\n}\n\n:host-context(.-theme-with-dark-background) .breakpoint-item.hit {\n  background-color: hsl(46deg 98% 22%);\n  color: var(--color-text-primary);\n}\n\n.-theme-with-dark-background .type-indicator,\n:host-context(.-theme-with-dark-background) .type-indicator {\n  --override-color-conditional-breakpoint: #e9a33a;\n  --override-color-logpoint: #e54d9b;\n}\n\n.breakpoint-item.logpoint > label > .type-indicator {\n  border-color: var(--override-color-logpoint);\n}\n\n.breakpoint-item.conditional-breakpoint > label > .type-indicator {\n  border-color: var(--override-color-conditional-breakpoint);\n}\n\n.checkbox-label {\n  display: flex;\n  align-items: center;\n}\n\n.checkbox-label > input {\n  margin-left: 16px;\n  margin-right: 6px;\n}\n\nsummary:hover .file-icon {\n  display: none;\n}\n\n.group-checkbox {\n  margin: 0;\n  display: none;\n}\n\nsummary:hover .group-checkbox {\n  display: flex;\n}\n\n.location {\n  line-height: 14px;\n  text-overflow: ellipsis;\n  overflow: hidden;\n}\n\n.breakpoint-item:hover button {\n  display: flex;\n}\n\n.pause-on-uncaught-exceptions {\n  margin-top: 3px;\n}\n\n.pause-on-caught-exceptions {\n  margin-bottom: 3px;\n}\n\n/* TODO(crbug.com/1382762): Remove special casing with dependent toggles as soon as Node LTS caught up on independent pause of exception toggles. */\ninput:disabled + span {\n  color: var(--color-text-disabled);\n}\n\n.pause-on-caught-exceptions > .checkbox-label > input,\n.pause-on-uncaught-exceptions > .checkbox-label > input {\n  margin-left: 6px;\n}\n\n.pause-on-caught-exceptions > .checkbox-label > span,\n.pause-on-uncaught-exceptions > .checkbox-label > span {\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n}\n\n.pause-on-uncaught-exceptions,\n.pause-on-caught-exceptions {\n  line-height: 13px;\n  height: 18px;\n  padding-right: 8px;\n}\n\ndetails > summary:focus,\n.breakpoint-item:focus,\n.pause-on-uncaught-exceptions:focus,\n.pause-on-caught-exceptions:focus {\n  background-color: var(--legacy-focus-bg-color);\n  outline-width: 0;\n}\n\n/*# sourceURL=breakpointsView.css */\n');export default styles;