export default{cssContent:"/*\n * Copyright 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.infobar {\n  color: var(--color-text-primary);\n  display: flex;\n  flex: auto;\n  flex-direction: column;\n  position: relative;\n  padding: 1px 6px;\n}\n\n.infobar:focus {\n  box-shadow: 0 0 0 2px var(--color-background-elevation-2) inset;\n}\n\n.infobar-warning {\n  --override-infobar-warning-background: rgb(253 242 192);\n\n  background-color: var(--override-infobar-warning-background);\n}\n\n.infobar-error {\n  --override-infobar-error-background: var(--color-error-background);\n  --override-infobar-error-text: var(--color-error-text);\n\n  background-color: var(--override-infobar-error-background);\n  color: var(--override-infobar-error-text);\n}\n\n.-theme-with-dark-background .infobar-warning,\n:host-context(.-theme-with-dark-background) .infobar-warning {\n  --override-infobar-warning-background: rgb(63 52 2);\n}\n\n.infobar-main-row {\n  display: flex;\n  flex-direction: row;\n  justify-content: flex-start;\n  min-height: 25px;\n}\n\n.infobar-info-container {\n  display: flex;\n  align-items: center;\n  flex-grow: 1;\n  flex-wrap: wrap;\n}\n\n.infobar-info-message {\n  display: flex;\n  margin: 5px 0;\n}\n\n.infobar-info-text {\n  display: flex;\n  align-items: center;\n  margin: 0 4px;\n}\n\n.infobar-details-rows {\n  padding: 5px 5px 0;\n}\n\n.infobar-details-row {\n  display: flex;\n  flex-direction: column;\n  line-height: 18px;\n  padding-bottom: 6px;\n}\n\n.infobar-close-container {\n  display: flex;\n  flex-shrink: 0;\n  align-items: center;\n}\n\n.infobar-close-container > .infobar-button.link-style {\n  margin: 4px;\n}\n\n.infobar-selectable {\n  user-select: text;\n}\n\n.infobar-button {\n  color: var(--color-text-secondary);\n  cursor: pointer;\n  padding: 0 4px;\n}\n\n.info-icon {\n  -webkit-mask-image: var(--image-file-info);\n  background-color: var(--icon-info);\n}\n\n.warning-icon {\n  -webkit-mask-image: var(--image-file-warning);\n  background-color: var(--icon-warning);\n}\n\n.error-icon {\n  -webkit-mask-image: var(--image-file-cross-circle);\n  background-color: var(--icon-error);\n}\n\n.issue-icon {\n  -webkit-mask-image: var(--image-file-issue-text-filled);\n  background-color: var(--icon-info);\n}\n\n.icon {\n  -webkit-mask-size: 20px 20px;\n  width: 20px;\n  height: 20px;\n  flex-shrink: 0;\n}\n\n.devtools-link.text-button:hover,\n.devtools-link.text-button:focus,\n.devtools-link.text-button:active {\n  background-color: transparent;\n  box-shadow: none;\n}\n"};