export default{cssContent:"/*\n * Copyright 2020 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n/**\n * These are the new set of colors for the new Light/Dark themes. See\n * https://crbug.com/1122511 and\n * https://docs.google.com/document/d/1QrSSRsJRzaQBY3zz73ZL84bTcFUV60yMtE5cuu6ED14\n * for details.\n*/\n:root {\n  --color-primary-old: rgb(26 115 232);\n  --color-primary-variant: rgb(66 133 244);\n  --color-background: rgb(255 255 255);\n  --color-background-inverted: rgb(0 0 0);\n  --color-background-inverted-opacity-0: rgb(0 0 0 / 0%);\n  --color-background-inverted-opacity-2: rgb(0 0 0 / 2%);\n  --color-background-inverted-opacity-30: rgb(0 0 0 / 30%);\n  --color-background-inverted-opacity-50: rgb(0 0 0 / 50%);\n  --color-background-opacity-50: rgb(255 255 255 / 50%);\n  --color-background-opacity-80: rgb(255 255 255 / 80%);\n  --color-background-elevation-0: rgb(248 249 249);\n  --color-background-elevation-1: rgb(241 243 244);\n  --color-background-elevation-2: rgb(222 225 230);\n  /** Used when the elevation is visible only on dark theme */\n  --color-background-elevation-dark-only: var(--color-background);\n  --color-background-highlight: rgb(218 220 224);\n  /** To draw grid lines behind elements */\n  --divider-line: rgb(0 0 0 / 10%);\n  /**\n   * When hovering over an element and the background should be a little\n   * bit darker. For example, when hovering over a node in the flame chart\n   * tree in the performance panel. This color is intentionally opague,\n   * since the color of the underlying element should still be dominant.\n   */\n  --color-background-hover-overlay: rgb(56 121 217 / 10%);\n  /**\n   * Used when selecting a range of a section, for example when\n   * selecting a range in the performance panel timeline.\n   */\n  --color-selection-highlight: rgb(56 121 217 / 30%);\n  --color-selection-highlight-border: rgb(16 81 177);\n  /**\n   * When showing matching elements of a particular search filter (for example\n   * when showing all matching css selectors/rules in the elements style\n   * pane). The highlight is intended to be used on top of the original background\n   * color and text color.\n   */\n  --color-match-highlight: rgb(56 121 217 / 20%);\n  --color-text-primary: rgb(32 33 36);\n  --color-text-secondary: rgb(95 99 104);\n  --color-text-secondary-selected: rgb(188 185 182);\n  --color-text-disabled: rgb(128 134 139);\n  --color-details-hairline: rgb(202 205 209);\n  --color-details-hairline-light: rgb(223 225 227);\n  --color-accent-red: rgb(217 48 37);\n  --color-red: rgb(238 68 47);\n  --color-accent-green: rgb(24 128 56);\n  --color-accent-green-background: rgb(24 128 56 / 10%);\n  --color-green: rgb(99 172 190);\n  --color-link: var(--color-primary-old);\n  --color-syntax-1: rgb(200 0 0);\n  --color-syntax-2: rgb(136 18 128);\n  --color-syntax-3: rgb(26 26 166);\n  --color-syntax-4: rgb(153 69 0);\n  --color-syntax-5: rgb(132 240 255);\n  --color-syntax-6: rgb(35 110 37);\n  --color-syntax-7: rgb(48 57 66);\n  --color-syntax-8: rgb(168 148 166);\n  --drop-shadow:\n    0 0 0 1px rgb(0 0 0 / 5%),\n    0 2px 4px rgb(0 0 0 / 20%),\n    0 2px 6px rgb(0 0 0 / 10%);\n  --drop-shadow-depth-1:\n    0 1px 2px rgb(60 64 67 / 30%),\n    0 1px 3px 1px rgb(60 64 67 / 15%);\n  --drop-shadow-depth-2:\n    0 1px 2px rgb(60 64 67 / 30%),\n    0 2px 6px 2px rgb(60 64 67 / 15%);\n  --drop-shadow-depth-3:\n    0 4px 8px 3px rgb(60 64 67 / 15%),\n    0 1px 3px rgb(60 64 67 / 30%);\n  --drop-shadow-depth-4:\n    0 6px 10px 4px rgb(60 64 67 / 15%),\n    0 2px 3px rgb(60 64 67 / 30%);\n  --drop-shadow-depth-5:\n    0 8px 12px 6px rgb(60 64 67 / 15%),\n    0 4px 4px rgb(60 64 67 / 30%);\n  --box-shadow-outline-color: rgb(0 0 0 / 50%);\n  /** These are the colors of the native Mac scrollbars */\n  --color-scrollbar-mac: rgb(143 143 143 / 60%);\n  --color-scrollbar-mac-hover: rgb(64 64 64 / 60%);\n  /** These colors are used on all non-Mac platforms for scrollbars */\n  --color-scrollbar-other: rgb(0 0 0 / 50%);\n  --color-scrollbar-other-hover: rgb(0 0 0 / 50%);\n  /** These colors have the same value in dark mode */\n  --lighthouse-red: rgb(255 78 67);\n  --lighthouse-orange: rgb(255 164 0);\n  --lighthouse-green: rgb(12 206 106);\n  /** The colors are for issue icons and related highlights */\n  --issue-color-red: rgb(235 57 65);\n  --issue-color-yellow: rgb(242 153 0);\n  --issue-color-blue: rgb(26 115 232);\n  /** Used to indicate an input box */\n  --input-outline: rgb(202 205 209);\n\n  /** These colors are used to show errors */\n  --color-error-text: #f00;\n  --color-error-border: hsl(0deg 100% 92%);\n  --color-error-background: hsl(0deg 100% 97%);\n  --color-checkbox-accent-color: var(--color-primary-old);\n  --color-image-preview-background: rgb(255 255 255);\n\n  /* Colors for styling inputs */\n  --color-input-outline: rgb(218 220 224);\n  --color-input-outline-active: rgb(26 115 232);\n  --color-input-outline-error: rgb(217 48 37);\n  --color-input-outline-disabled: rgba(128 134 139 / 20%);\n  --color-input-text-disabled: rgba(128 134 139 / 50%);\n\n  /* Colors for styling buttons */\n  --color-button-outline-focus: rgb(26 115 232 / 50%);\n  --color-button-primary-background-hovering: rgb(77 134 225 / 100%);\n  --color-button-primary-background-pressed: rgb(88 132 205);\n  --color-button-primary-text: rgb(255 255 255);\n  --color-button-primary-text-hover: rgb(218 220 224);\n  --color-button-secondary-background-hovering: rgb(26 115 232 / 10%);\n  --color-button-secondary-background-pressed: rgb(26 92 178 / 25%);\n  --color-button-secondary-border: rgb(218 220 224);\n  --color-iconbutton-hover: rgb(0 0 0 / 10%);\n  --color-iconbutton-pressed: rgb(0 0 0 / 15%);\n\n  /* Colors for file icons */\n  --color-ic-file-document: rgb(39 116 240);\n  --color-ic-file-image: rgb(46 184 83);\n  --color-ic-file-font: rgb(18 192 226);\n  --color-ic-file-script: rgb(240 179 0);\n  --color-ic-file-stylesheet: rgb(174 82 255);\n  --color-ic-file-webbundle: rgb(128 134 139);\n  --color-ic-file-default: rgb(128 134 139);\n\n  /* Code highlighting colors */\n  --color-token-variable: inherit;\n  --color-token-property: inherit;\n  --color-token-type: rgb(0 136 119);\n  --color-token-definition: var(--color-token-attribute-value);\n  --color-token-variable-special: rgb(0 85 170);\n  --color-token-builtin: rgb(50 0 170);\n  --color-token-keyword: rgb(171 13 144);\n  --color-token-number: rgb(50 0 255);\n  --color-token-string: rgb(170 17 17);\n  --color-token-string-special: rgb(200 0 0);\n  --color-token-atom: rgb(34 17 153);\n  --color-token-tag: rgb(136 18 128);\n  --color-token-attribute: rgb(153 69 0);\n  --color-token-attribute-value: rgb(26 26 168);\n  --color-token-comment: rgb(0 117 0);\n  --color-token-meta: rgb(85 85 85);\n  --color-token-deleted: rgb(221 68 68);\n  --color-token-inserted: rgb(34 153 34);\n\n  /* Colors used by the code editor */\n  --color-secondary-cursor: #c0c0c0;\n  --color-line-number: hsl(0deg 0% 46%);\n  --color-matching-bracket-underline: rgb(0 0 0 / 50%);\n  --color-matching-bracket-background: rgb(0 0 0 / 7%);\n  --color-nonmatching-bracket-underline: rgb(255 0 0 / 50%);\n  --color-nonmatching-bracket-background: rgb(255 0 0 / 7%);\n  --color-editor-selection: #cfe8fc;\n  --color-editor-selection-blurred: #e0e0e0;\n  --color-trailing-whitespace: rgb(255 0 0 / 5%);\n  --color-selected-option: #fff;\n  --color-selected-option-background: #1a73e8;\n  --color-selected-option-outline: rgb(255 255 255 / 50%);\n  --color-highlighted-line: rgb(255 255 0 / 50%);\n  --color-completion-hover: rgb(56 121 217 / 10%);\n  --color-search-match-border: rgb(128 128 128);\n  --color-selected-search-match: var(--color-text-primary);\n  --color-selected-search-match-background: rgb(241 234 0);\n  --color-coverage-used: #63acbe;\n  --color-execution-line-background: rgb(0 59 255 / 10%);\n  --color-execution-line-outline: rgb(64 115 244);\n  --color-execution-token-background: rgb(15 72 252 / 35%);\n  --color-continue-to-location: rgb(5 65 255 / 10%);\n  --color-continue-to-location-hover: rgb(15 72 252 / 35%);\n  --color-continue-to-location-hover-border: rgb(121 141 254);\n  --color-continue-to-location-async: rgb(58 162 8 / 30%);\n  --color-continue-to-location-async-hover: rgb(75 179 6 / 55%);\n  --color-continue-to-location-async-hover-border: rgb(100 154 100);\n  --color-evaluated-expression: rgb(255 255 11 / 25%);\n  --color-evaluated-expression-border: rgb(163 41 34);\n  --color-variable-values: #ffe3c7;\n  --color-non-breakable-line: rgb(128 128 128 / 40%);\n\n  /* Color tokens for icons */\n  --color-on-surface: rgb(32 33 36);\n  --color-on-surface-variant: rgb(110 110 110);\n  --color-primary: rgb(11 87 208);\n  --color-primary-bright: rgb(27 110 243);\n  --color-on-primary: rgb(255 255 255);\n  --color-orange: rgb(169 91 18);\n  --color-orange-bright: rgb(232 143 33);\n  --color-tertiary: rgb(20 108 46);\n  --color-tertiary-bright: rgb(25 134 57);\n  --color-error: rgb(179 38 30);\n  --color-error-bright: rgb(220 54 46);\n  --color-purple: rgb(140 30 211);\n  --color-purple-bright: rgb(167 67 238);\n  --color-turqoise: rgb(0 103 127);\n  --color-turqoise-bright: rgb(0 152 196);\n  --color-yellow: rgb(121 89 0);\n  --color-yellow-bright: rgb(186 130 14);\n\n  /* Chrome Desktop Design System */\n\n  /* Use on all surfaces */\n\n  --sys-color-on-surface: var(--ref-palette-neutral10);\n  --sys-color-on-surface-subtle: var(--ref-palette-neutral30);\n  --sys-color-on-surface-secondary: var(--ref-palette-neutral30);\n  --sys-color-on-surface-primary: var(--ref-palette-primary10);\n\n  /* Universal surfaces */\n\n  --sys-color-surface: var(--ref-palette-neutral100);\n  --sys-color-surface-variant: var(--ref-palette-neutral-variant90);\n\n  /* Containers */\n\n  --sys-color-tonal-container: var(--ref-palette-primary90);\n  --sys-color-on-tonal-container: var(--ref-palette-primary10);\n  --sys-color-tertiary-container: var(--ref-palette-tertiary90);\n  --sys-color-on-tertiary-container: var(--ref-palette-tertiary10);\n  --sys-color-error-container: var(--ref-palette-error90);\n  --sys-color-on-error-container: var(--ref-palette-error10);\n  --sys-color-neutral-container: var(--ref-palette-neutral95);\n  --sys-color-omnibox-container: var(--sys-color-surface4);\n\n  /* Prominent accent colors */\n\n  --sys-color-primary: var(--ref-palette-primary40);\n  --sys-color-on-primary: var(--ref-palette-primary100);\n  --sys-color-secondary: var(--ref-palette-secondary40);\n  --sys-color-on-secondary: var(--ref-palette-secondary100);\n  --sys-color-tertiary: var(--ref-palette-tertiary40);\n  --sys-color-on-tertiary: var(--ref-palette-tertiary100);\n  --sys-color-error: var(--ref-palette-error40);\n  --sys-color-on-error: var(--ref-palette-error100);\n\n  /* Chrome base surface */\n\n  --sys-color-base: var(--ref-palette-neutral100);\n  --sys-color-base-container: var(--sys-color-surface4);\n  --sys-color-base-container-elevated: var(--ref-palette-neutral100);\n\n  /* Corresponding base on colors */\n\n  --sys-color-on-base: var(--ref-palette-neutral10);\n  --sys-color-on-base-divider: var(--ref-palette-primary90);\n  /* Inverse */\n\n  --sys-color-inverse-surface: var(--ref-palette-neutral20);\n  --sys-color-inverse-primary: var(--ref-palette-primary80);\n  --sys-color-inverse-on-surface: var(--ref-palette-neutral95);\n\n  /* Outlines */\n\n  --sys-color-color-outline: var(--ref-palette-neutral-variant50);\n  --sys-color-tonal-outline: var(--ref-palette-primary80);\n  --sys-color-neutral-outline: var(--ref-palette-neutral80);\n  --sys-color-divider: var(--ref-palette-primary90);\n\n  /* States */\n\n  --sys-color-state-hover-on-prominent: rgb(253 252 251 / 10%);\n  --sys-color-state-hover-on-subtle: rgb(31 31 31 / 6%);\n  --sys-color-state-hover-dim-blend-protection: rgb(6 46 111 / 18%);\n  --sys-color-state-hover-bright-blend-protection: rgb(31 31 31 / 6%);\n  --sys-color-state-ripple-neutral-on-prominent: rgb(253 252 251 / 16%);\n  --sys-color-state-ripple-neutral-on-subtle: rgb(31 31 31 / 8%);\n  --sys-color-state-ripple-primary: rgb(124 172 248 / 32%);\n  --sys-color-state-focus-ring: var(--ref-palette-primary40);\n  --sys-color-state-focus-highlight: rgb(31 31 31 / 6%);\n  --sys-color-state-disabled: rgb(31 31 31 / 38%);\n  --sys-color-state-disabled-container: rgb(31 31 31 / 12%);\n  --sys-color-state-header-hover: var(--ref-palette-primary80);\n  --sys-color-state-on-header-hover: var(--ref-palette-primary20);\n\n  /* Surfaces */\n\n  --sys-color-surface5: rgb(234 240 249 / 100%);\n  --sys-color-surface4: rgb(237 239 246 / 100%);\n  --sys-color-surface3: rgb(238 243 250 / 100%);\n  --sys-color-surface2: rgb(243 246 252 / 100%);\n  --sys-color-surface1: rgb(247 249 253 / 100%);\n\n  /* Chrome DevTools Design System */\n\n  /* Prominent accent colors for icons */\n\n  --sys-color-primary-bright: var(--ref-palette-primary50);\n  --sys-color-blue-bright: var(--ref-palette-blue50);\n  --sys-color-green-bright: var(--ref-palette-green50);\n  --sys-color-error-bright: var(--ref-palette-error50);\n  --sys-color-orange-bright: var(--ref-palette-orange65);\n  --sys-color-yellow-bright: var(--ref-palette-yellow55);\n  --sys-color-cyan-bright: var(--ref-palette-cyan50);\n  --sys-color-purple-bright: var(--ref-palette-purple50);\n  --sys-color-neutral-bright: var(--ref-palette-neutral70);\n\n  /* Prominent accent colors for text */\n\n  --sys-color-blue: var(--ref-palette-blue40);\n  --sys-color-on-blue: var(--ref-palette-blue100);\n  --sys-color-green: var(--ref-palette-green40);\n  --sys-color-on-green: var(--ref-palette-green100);\n  --sys-color-orange: var(--ref-palette-orange40);\n  --sys-color-on-orange: var(--ref-palette-orange100);\n  --sys-color-yellow: var(--ref-palette-yellow40);\n  --sys-color-on-yellow: var(--ref-palette-yellow100);\n  --sys-color-cyan: var(--ref-palette-cyan40);\n  --sys-color-on-cyan: var(--ref-palette-cyan100);\n  --sys-color-purple: var(--ref-palette-purple40);\n  --sys-color-on-purple: var(--ref-palette-purple100);\n\n  /* Containers */\n\n  --sys-color-yellow-container: var(--ref-palette-yellow90);\n  --sys-color-on-yellow-container: var(--ref-palette-yellow10);\n\n  /* Universal surfaces */\n\n  --sys-color-cdt-base: var(--sys-color-base-container);\n  --sys-color-cdt-base-container: var(--sys-color-base);\n\n  /* Tinted surfaces */\n\n  --sys-color-surface-yellow: rgb(254 243 220 / 100%);\n  --sys-color-surface-error: rgb(252 235 235 / 100%);\n\n  /* Corresponding on colors */\n\n  --sys-color-on-surface-yellow: var(--ref-palette-yellow20);\n  --sys-color-on-surface-error: var(--ref-palette-error30);\n\n  /* Syntax highlighting */\n\n  --sys-color-token-variable: var(--sys-color-on-surface);\n  --sys-color-token-property: var(--sys-color-on-surface);\n  --sys-color-token-property-special: var(--ref-palette-error50);\n  --sys-color-token-type: var(--ref-palette-tertiary50);\n  --sys-color-token-definition: var(--ref-palette-primary30);\n  --sys-color-token-variable-special: var(--ref-palette-primary30);\n  --sys-color-token-builtin: var(--ref-palette-primary20);\n  --sys-color-token-keyword: var(--ref-palette-pink40);\n  --sys-color-token-number: var(--ref-palette-primary40);\n  --sys-color-token-string: var(--ref-palette-error40);\n  --sys-color-token-string-special: var(--ref-palette-error50);\n  --sys-color-token-atom: var(--ref-palette-primary20);\n  --sys-color-token-tag: var(--ref-palette-pink30);\n  --sys-color-token-attribute: var(--ref-palette-orange40);\n  --sys-color-token-attribute-value: var(--ref-palette-primary30);\n  --sys-color-token-comment: var(--ref-palette-tertiary40);\n  --sys-color-token-meta: var(--ref-palette-neutral60);\n  --sys-color-token-deleted: var(--ref-palette-error50);\n  --sys-color-token-inserted: var(--ref-palette-tertiary60);\n  --sys-color-token-pseudo-element: var(--ref-palette-primary40);\n  --sys-color-token-subtle: var(--ref-palette-neutral60);\n}\n\n.-theme-with-dark-background {\n  --color-primary-old: rgb(138 180 248);\n  --color-primary-variant: rgb(102 157 246);\n  --color-background: rgb(32 33 36);\n  --color-background-inverted: rgb(255 255 255);\n  --color-background-inverted-opacity-2: rgb(255 255 255 / 2%);\n  --color-background-inverted-opacity-30: rgb(255 255 255 / 30%);\n  --color-background-inverted-opacity-50: rgb(255 255 255 / 50%);\n  --color-background-opacity-50: rgb(32 33 36 / 50%);\n  --color-background-opacity-80: rgb(32 33 36 / 80%);\n  --color-background-elevation-0: rgb(32 32 35);\n  --color-background-elevation-1: rgb(41 42 45);\n  --color-background-elevation-2: rgb(53 54 58);\n  --color-background-elevation-dark-only: var(--color-background-elevation-1);\n  --color-background-highlight: rgb(69 69 69);\n  --divider-line: rgb(255 255 255 / 10%);\n  --color-background-hover-overlay: rgb(56 121 217 / 10%);\n  --color-selection-highlight: rgb(251 202 70 / 20%);\n  --color-selection-highlight-border: rgb(251 202 70);\n  --color-match-highlight: rgb(56 121 217 / 35%);\n  --color-text-primary: rgb(232 234 237);\n  --color-text-secondary: rgb(154 160 166);\n  --color-text-secondary-selected: rgb(188 185 182);\n  --color-text-disabled: rgb(128 134 139);\n  --color-details-hairline: rgb(73 76 80);\n  --color-details-hairline-light: rgb(54 57 59);\n  --color-accent-red: rgb(242 139 130);\n  --color-red: rgb(237 78 76);\n  --color-accent-green: rgb(129 201 149);\n  --color-accent-green-background: rgb(129 201 149 / 20%);\n  --color-link: var(--color-primary-old);\n  --color-syntax-1: rgb(53 212 199);\n  --color-syntax-2: rgb(93 176 215);\n  --color-syntax-2-rgb: 93 176 215;\n  --color-syntax-3: rgb(242 151 102);\n  --color-syntax-4: rgb(155 187 220);\n  --color-syntax-5: rgb(132 240 255);\n  --color-syntax-6: rgb(171 171 171);\n  --color-syntax-7: rgb(207 208 208);\n  --color-syntax-8: rgb(93 176 215);\n  --drop-shadow:\n    0 0 0 1px rgb(255 255 255 / 20%),\n    0 2px 4px 2px rgb(0 0 0 / 20%),\n    0 2px 6px 2px rgb(0 0 0 / 10%);\n  --drop-shadow-depth-1:\n    0 1px 2px rgb(0 0 0 / 30%),\n    0 1px 3px 1px rgb(0 0 0 / 15%);\n  --drop-shadow-depth-2:\n    0 1px 2px rgb(0 0 0 / 30%),\n    0 2px 6px 2px rgb(0 0 0 / 15%);\n  --drop-shadow-depth-3:\n    0 4px 8px 3px rgb(0 0 0 / 15%),\n    0 1px 3px rgb(0 0 0 / 30%);\n  --drop-shadow-depth-4:\n    0 6px 10px 4px rgb(0 0 0 / 15%),\n    0 2px 3px rgb(0 0 0 / 30%);\n  --drop-shadow-depth-5:\n    0 8px 12px 6px rgb(0 0 0 / 15%),\n    0 4px 4px rgb(0 0 0 / 30%);\n  --box-shadow-outline-color: rgb(0 0 0 / 50%);\n  --color-scrollbar-mac: rgb(51 51 51);\n  --color-scrollbar-mac-hover: rgb(75 76 79);\n  --color-scrollbar-other: rgb(51 51 51);\n  --color-scrollbar-other-hover: rgb(75 76 79);\n  --color-error-text: hsl(0deg 100% 75%);\n  --color-error-border: rgb(92 0 0);\n  --color-error-background: hsl(0deg 100% 8%);\n  --color-checkbox-accent-color: rgb(255 165 0);\n  /* Colors for styling inputs */\n  --color-input-outline: rgb(60 64 67);\n  --color-input-outline-active: rgb(138 180 248);\n  --color-input-outline-error: rgb(242 139 130);\n  --color-input-outline-disabled: rgba(189 193 198 / 20%);\n  --color-input-text-disabled: rgba(128 134 139 / 70%);\n  /* Colors for styling buttons */\n  --color-button-outline-focus: rgb(138 180 248 / 75%);\n  --color-button-primary-background-hovering: rgb(174 203 250 / 100%);\n  --color-button-primary-background-pressed: rgb(210 227 252 / 100%);\n  --color-button-primary-text: rgb(0 0 0);\n  --color-button-primary-text-hover: rgb(60 61 65);\n  --color-button-secondary-background-hovering: rgb(138 180 248 / 15%);\n  --color-button-secondary-background-pressed: rgb(138 180 248 / 23%);\n  --color-button-secondary-border: rgb(60 61 65);\n  --color-iconbutton-hover: rgb(255 255 255 / 12%);\n  --color-iconbutton-pressed: rgb(255 255 255 / 20%);\n\n  /* Colors for file icons */\n  --color-ic-file-document: rgb(39 116 240);\n  --color-ic-file-image: rgb(30 142 62);\n  --color-ic-file-font: rgb(18 181 203);\n  --color-ic-file-script: rgb(234 134 0);\n  --color-ic-file-stylesheet: rgb(161 66 244);\n  --color-ic-file-webbundle: rgb(128 134 139);\n  --color-ic-file-default: rgb(128 134 139);\n\n  /* Code highlighting colors */\n  --color-token-variable: rgb(217 217 217);\n  --color-token-property: rgb(210 192 87);\n  --color-token-type: var(--color-token-tag);\n  --color-token-definition: var(--color-token-tag);\n  --color-token-builtin: rgb(159 180 214);\n  --color-token-variable-special: rgb(0 85 170);\n  --color-token-keyword: rgb(154 127 213);\n  --color-token-string: rgb(242 139 84);\n  --color-token-string-special: var(--color-token-string);\n  --color-token-atom: rgb(161 247 181);\n  --color-token-number: var(--color-token-atom);\n  --color-token-comment: var(--color-syntax-6);\n  --color-token-tag: rgb(93 176 215);\n  --color-token-attribute: rgb(155 187 220);\n  --color-token-attribute-value: rgb(242 151 102);\n  --color-token-meta: rgb(221 251 85);\n\n  /* Colors used by the code editor */\n  --color-secondary-cursor: rgb(63 63 63);\n  --color-line-number: rgb(138 138 138);\n  --color-matching-bracket-underline: rgb(217 217 217);\n  --color-matching-bracket-background: initial;\n  --color-nonmatching-bracket-underline: rgb(255 26 26);\n  --color-nonmatching-bracket-background: initial;\n  --color-editor-selection: hsl(207deg 88% 22%);\n  --color-editor-selection-blurred: #454545;\n  --color-trailing-whitespace: rgb(255 0 0 / 5%);\n  --color-selected-option: #fff;\n  --color-selected-option-background: #0e639c;\n  --color-selected-option-outline: rgb(0 0 0 / 50%);\n  --color-highlighted-line: hsl(133deg 100% 30% / 50%);\n  --color-completion-hover: rgb(56 121 217 / 10%);\n  --color-search-match-border: rgb(128 128 128);\n  --color-selected-search-match: #eee;\n  --color-selected-search-match-background: hsl(133deg 100% 30%);\n  --color-coverage-used: rgb(65 138 156);\n  --color-execution-line-background: rgb(0 154 17 / 30%);\n  --color-execution-line-outline: #33cc6b;\n  --color-execution-token-background: rgb(132 237 78 / 20%);\n  --color-continue-to-location: rgb(0 173 56 / 35%);\n  --color-continue-to-location-hover: rgb(0 173 56 / 35%);\n  --color-continue-to-location-hover-border: #33cc6b;\n  --color-continue-to-location-async: rgb(87 238 0 / 20%);\n  --color-continue-to-location-async-hover: rgb(128 241 48 / 50%);\n  --color-continue-to-location-async-hover-border: rgb(101 155 101);\n  --color-evaluated-expression: rgb(71 70 0 / 75%);\n  --color-evaluated-expression-border: rgb(221 99 92);\n  --color-variable-values: rgb(56 28 0);\n  --color-non-breakable-line: rgb(127 127 127 / 40%);\n\n  /* Color tokens for icons */\n  --color-on-surface: rgb(232 234 237);\n  --color-on-surface-variant: rgb(145 145 145);\n  --color-primary: rgb(168 199 250);\n  --color-primary-bright: rgb(124 172 248);\n  --color-on-primary: rgb(255 255 255);\n  --color-orange: rgb(255 184 113);\n  --color-orange-bright: rgb(238 152 54);\n  --color-tertiary: rgb(109 213 140);\n  --color-tertiary-bright: rgb(55 190 95);\n  --color-error: rgb(242 184 181);\n  --color-error-bright: rgb(228 105 98);\n  --color-purple: rgb(226 182 255);\n  --color-purple-bright: rgb(209 144 255);\n  --color-turqoise: rgb(92 213 251);\n  --color-turqoise-bright: rgb(56 185 222);\n  --color-yellow: rgb(251 188 5);\n  --color-yellow-bright: rgb(217 162 0);\n\n  /* Chrome Desktop Design System */\n\n  /* Use on all surfaces */\n\n  --sys-color-on-surface: var(--ref-palette-neutral90);\n  --sys-color-on-surface-subtle: var(--ref-palette-neutral80);\n  --sys-color-on-surface-secondary: var(--ref-palette-neutral80);\n  --sys-color-on-surface-primary: var(--ref-palette-primary90);\n\n  /* Universal surfaces */\n\n  --sys-color-surface: var(--ref-palette-neutral10);\n  --sys-color-surface-variant: var(--ref-palette-neutral-variant30);\n\n  /* Containers */\n\n  --sys-color-tonal-container: var(--ref-palette-secondary30);\n  --sys-color-on-tonal-container: var(--ref-palette-secondary90);\n  --sys-color-tertiary-container: var(--ref-palette-tertiary30);\n  --sys-color-on-tertiary-container: var(--ref-palette-tertiary90);\n  --sys-color-error-container: var(--ref-palette-error30);\n  --sys-color-on-error-container: var(--ref-palette-error90);\n  --sys-color-neutral-container: var(--ref-palette-neutral15);\n  --sys-color-omnibox-container: var(--ref-palette-neutral15);\n\n  /* Prominent accent colors */\n\n  --sys-color-primary: var(--ref-palette-primary80);\n  --sys-color-on-primary: var(--ref-palette-primary20);\n  --sys-color-secondary: var(--ref-palette-secondary80);\n  --sys-color-on-secondary: var(--ref-palette-secondary20);\n  --sys-color-tertiary: var(--ref-palette-tertiary80);\n  --sys-color-on-tertiary: var(--ref-palette-tertiary20);\n  --sys-color-error: var(--ref-palette-error80);\n  --sys-color-on-error: var(--ref-palette-error20);\n\n  /* Chrome base surface */\n\n  --sys-color-base: var(--ref-palette-neutral25);\n  --sys-color-base-container: var(--ref-palette-neutral15);\n  --sys-color-base-container-elevated: var(--ref-palette-neutral25);\n\n  /* Corresponding base on colors */\n\n  --sys-color-on-base: var(--ref-palette-neutral90);\n  --sys-color-on-base-divider: var(--ref-palette-neutral40);\n\n  /* Inverse */\n\n  --sys-color-inverse-surface: var(--ref-palette-neutral90);\n  --sys-color-inverse-primary: var(--ref-palette-primary40);\n  --sys-color-inverse-on-surface: var(--ref-palette-neutral10);\n\n  /* Outlines */\n\n  --sys-color-outline: var(--ref-palette-neutral-variant60);\n  --sys-color-tonal-outline: var(--ref-palette-secondary40);\n  --sys-color-neutral-outline: var(--ref-palette-neutral40);\n  --sys-color-divider: var(--ref-palette-neutral30);\n\n  /* States */\n\n  --sys-color-state-hover-on-prominent: rgb(31 31 31 / 6%);\n  --sys-color-state-hover-on-subtle: rgb(253 252 251 / 10%);\n  --sys-color-state-hover-dim-blend-protection: rgb(31 31 31 / 10%);\n  --sys-color-state-hover-bright-blend-protection: rgb(31 31 31 / 16%);\n  --sys-color-state-ripple-neutral-on-prominent: rgb(31 31 31 / 12%);\n  --sys-color-state-ripple-neutral-on-subtle: rgb(253 252 251 / 16%);\n  --sys-color-state-ripple-primary: rgb(76 141 246 / 32%);\n  --sys-color-state-focus-ring: var(--ref-palette-primary80);\n  --sys-color-state-focus-highlight: rgb(253 252 251 / 10%);\n  --sys-color-state-disabled: rgb(227 227 227 / 100%);\n  --sys-color-state-disabled-container: rgb(227 227 227 / 12%);\n  --sys-color-state-header-hover: var(--ref-palette-secondary30);\n  --sys-color-state-on-header-hover: var(--ref-palette-secondary90);\n\n  /* Surfaces */\n\n  --sys-color-surface5: rgb(56 58 62 / 100%);\n  --sys-color-surface4: rgb(52 54 58 / 100%);\n  --sys-color-surface3: rgb(51 52 56 / 100%);\n  --sys-color-surface2: rgb(45 47 49 / 100%);\n  --sys-color-surface1: rgb(40 41 42 / 100%);\n\n  /* Chrome DevTools Design System */\n\n  /* Prominent accent colors for icons */\n\n  --sys-color-primary-bright: var(--ref-palette-primary70);\n  --sys-color-blue-bright: var(--ref-palette-blue70);\n  --sys-color-green-bright: var(--ref-palette-tertiary70);\n  --sys-color-error-bright: var(--ref-palette-error60);\n  --sys-color-orange-bright: var(--ref-palette-orange70);\n  --sys-color-yellow-bright: var(--ref-palette-yellow70);\n  --sys-color-cyan-bright: var(--ref-palette-cyan70);\n  --sys-color-purple-bright: var(--ref-palette-purple70);\n  --sys-color-neutral-bright: var(--ref-palette-neutral50);\n\n  /* Prominent accent colors for text */\n\n  --sys-color-blue: var(--ref-palette-blue80);\n  --sys-color-on-blue: var(--ref-palette-blue20);\n  --sys-color-green: var(--ref-palette-green80);\n  --sys-color-on-green: var(--ref-palette-green20);\n  --sys-color-orange: var(--ref-palette-orange80);\n  --sys-color-on-orange: var(--ref-palette-orange20);\n  --sys-color-yellow: var(--ref-palette-yellow80);\n  --sys-color-on-yellow: var(--ref-palette-yellow20);\n  --sys-color-cyan: var(--ref-palette-cyan80);\n  --sys-color-on-cyan: var(--ref-palette-cyan20);\n  --sys-color-purple: var(--ref-palette-purple80);\n  --sys-color-on-purple: var(--ref-palette-purple20);\n\n  /* Containers */\n\n  --sys-color-yellow-container: var(--ref-palette-yellow30);\n  --sys-color-on-yellow-container: var(--ref-palette-yellow90);\n\n  /* Universal surfaces */\n\n  --sys-color-cdt-base: var(--sys-color-base);\n  --sys-color-cdt-base-container: var(--sys-color-base-container);\n\n  /* Tinted surfaces */\n\n  --sys-color-surface-yellow: rgb(65 58 42 / 100%);\n  --sys-color-surface-error: rgb(78 53 52 / 100%);\n\n  /* Corresponding on colors */\n\n  --sys-color-on-surface-yellow: var(--ref-palette-yellow90);\n  --sys-color-on-surface-error: var(--ref-palette-error90);\n\n  /* Syntax highlighting */\n\n  --sys-color-token-variable: var(--ref-palette-neutral80);\n  --sys-color-token-property: var(--ref-palette-yellow70);\n  --sys-color-token-property-special: var(--ref-palette-cyan80);\n  --sys-color-token-type: var(--ref-palette-primary70);\n  --sys-color-token-definition: var(--ref-palette-primary70);\n  --sys-color-token-variable-special: var(--ref-palette-primary40);\n  --sys-color-token-builtin: var(--ref-palette-primary80);\n  --sys-color-token-keyword: var(--ref-palette-primary40);\n  --sys-color-token-number: var(--ref-palette-tertiary90);\n  --sys-color-token-string: var(--ref-palette-orange70);\n  --sys-color-token-string-special: var(--ref-palette-orange70);\n  --sys-color-token-atom: var(--ref-palette-tertiary90);\n  --sys-color-token-tag: var(--ref-palette-primary70);\n  --sys-color-token-attribute: var(--ref-palette-primary80);\n  --sys-color-token-attribute-value: var(--ref-palette-orange70);\n  --sys-color-token-comment: var(--ref-palette-neutral70);\n  --sys-color-token-meta: var(--ref-palette-neutral60);\n  --sys-color-token-deleted: var(--ref-palette-error50);\n  --sys-color-token-inserted: var(--ref-palette-tertiary60);\n  --sys-color-token-pseudo-element: var(--ref-palette-pink70);\n  --sys-color-token-subtle: var(--ref-palette-neutral60);\n}\n"};